OpenTTD: NWidgetToolbarContainer Class Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Attributes | Private Attributes
NWidgetToolbarContainer Class Reference

Full blown container to make it behave exactly as we want :) More...

Inheritance diagram for NWidgetToolbarContainer:

## Public Member Functions
bool | IsButton (WidgetType type) const
| Check whether the given widget type is a button for us.
void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
void | Draw (const Window *w)
| Draw the widgets of the tree.
NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
virtual const byte * | GetButtonArrangement (uint &width, uint &arrangable_count, uint &button_count, uint &spacer_count) const =0
| Get the arrangement of the buttons for the toolbar.
Public Member Functions inherited from NWidgetContainer
| NWidgetContainer (WidgetType tp)
| Constructor container baseclass.
void | Add (NWidgetBase *wid)
| Append widget wid to container.
void | FillNestedArray (NWidgetBase **array, uint length)
bool | IsEmpty ()
| Return whether the container is empty.
NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type.
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor.
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted (TextColour highlight_colour)
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Protected Attributes
uint | spacers
| Number of spacer widgets in this toolbar.
Protected Attributes inherited from NWidgetContainer
NWidgetBase * | head
| Pointer to first widget in container.
NWidgetBase * | tail
| Pointer to last widget in container.

## Private Attributes
bool | visible [WID_TN_END]
| The visible headers.

## Additional Inherited Members
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
uint | pos_x
| Horizontal position of top-left corner of the widget in the window.
uint | pos_y
| Vertical position of top-left corner of the widget in the window.
NWidgetBase * | next
| Pointer to next widget in container. Managed by parent container widget.
NWidgetBase * | prev
| Pointer to previous widget in container. Managed by parent container widget.
uint8 | padding_top
| Paddings added to the top of the widget. Managed by parent container widget.
uint8 | padding_right
| Paddings added to the right of the widget. Managed by parent container widget. (parent container may swap this with padding_left for RTL)
uint8 | padding_bottom
| Paddings added to the bottom of the widget. Managed by parent container widget.
uint8 | padding_left
| Paddings added to the left of the widget. Managed by parent container widget. (parent container may swap this with padding_right for RTL)
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position.

## Detailed Description

Full blown container to make it behave exactly as we want :)

Definition at line 1307 of file toolbar_gui.cpp.

## Member Function Documentation

void NWidgetToolbarContainer::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| inlinevirtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 1360 of file toolbar_gui.cpp.

References NWidgetBase::AssignSizePosition(), NWidgetBase::current_x, NWidgetBase::current_y, GetButtonArrangement(), NWidgetContainer::head, IsButton(), max(), NWidgetBase::next, NWID_SPACER, NWidgetBase::pos_x, NWidgetBase::pos_y, NWidgetBase::prev, NWidgetBase::smallest_x, NWidgetBase::smallest_y, NWidgetBase::type, visible, and WID_TN_END.

void NWidgetToolbarContainer::Draw | ( | const Window * | w | ) |
| inlinevirtual

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1423 of file toolbar_gui.cpp.

References _current_text_dir, NWidgetBase::current_x, NWidgetBase::current_y, FILLRECT_CHECKER, GfxFillRect(), NWidgetContainer::head, NWidgetBase::next, NWID_SPACER, PC_DARK_RED, PC_VERY_DARK_RED, NWidgetBase::pos_x, NWidgetBase::pos_y, NWidgetBase::prev, NWidgetContainer::tail, TD_RTL, and visible.

virtual const byte* NWidgetToolbarContainer::GetButtonArrangement | ( | uint & | width,
|  | uint & | arrangable_count,
|  | uint & | button_count,
|  | uint & | spacer_count
| ) |  | const
| pure virtual

Get the arrangement of the buttons for the toolbar.

Parameters

  width | the new width of the toolbar.
  arrangable_count | output of the number of visible items.
  button_count | output of the number of visible buttons.
  spacer_count | output of the number of spacers.

Returns
  the button configuration.

Referenced by AssignSizePosition().

NWidgetCore* NWidgetToolbarContainer::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| inlinevirtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Implements NWidgetBase.

Definition at line 1438 of file toolbar_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, NWidgetCore::GetWidgetFromPos(), NWidgetContainer::head, IsInsideBS(), NWidgetBase::next, NWID_SPACER, NWidgetBase::pos_x, NWidgetBase::pos_y, and visible.

bool NWidgetToolbarContainer::IsButton | ( | WidgetType | type | ) | const
| inline

Check whether the given widget type is a button for us.

Parameters

  type | the widget type to check.

Returns
  true if it is a button for us.

Definition at line 1322 of file toolbar_gui.cpp.

References WWT_IMGBTN, WWT_IMGBTN_2, and WWT_PUSHIMGBTN.

Referenced by AssignSizePosition(), and SetupSmallestSize().

void NWidgetToolbarContainer::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array
| ) |  |
| inlinevirtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.
  init_array | Initialize the `w->nested_array`.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1327 of file toolbar_gui.cpp.

References _toolbar_width, NWidgetBase::fill_x, NWidgetBase::fill_y, NWidgetContainer::head, IsButton(), max(), NWidgetBase::next, NWID_SPACER, NWidgetBase::resize_x, NWidgetBase::resize_y, NWidgetBase::smallest_x, NWidgetBase::smallest_y, and spacers.

The documentation for this class was generated from the following file:

- src/toolbar_gui.cpp